#include <CoinMarketCapApi.h>
#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include <ArduinoJson.h>

#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>

Adafruit_PCD8544 display = Adafruit_PCD8544(16,0,4,5,2); 

char ssid[] = "Newton Sir";       // your network SSID (name)
char password[] = "Bulb'sfather";  // your network key


WiFiClientSecure client;
CoinMarketCapApi api(client);

// CoinMarketCap's limit is "no more than 10 per minute"
// Make sure to factor in if you are requesting more than one coin.
unsigned long api_mtbs = 60000; //mean time between api requests
unsigned long api_due_time = 0;

void setup() {

  Serial.begin(115200);
  display.begin();
  display.clearDisplay();
  display.setContrast(55); ;
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);

  // Attempt to connect to Wifi network:
  Serial.print("Connecting Wifi: ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);

  // checking if the wifi is connected to the network
  while (WiFi.status() != WL_CONNECTED)       
  {
    display.setTextSize(1);
    display.setTextColor(BLACK);
    display.setCursor(0, 0);
    display.println("Connecting...");
    Serial.print("Connecting..");
    delay(1000);
    display.display();
  }
  display.clearDisplay();
  Serial.println("Connected to");
  display.setCursor(0, 0);
  display.print("Connected to");
  delay(500);
  display.print("                ");
  Serial.println(ssid);
  display.setCursor(5, 19);//x,y-->84,48
  display.print(ssid);
  display.display();
  delay(1000);
}

void printTickerData(String ticker) {
  Serial.println("---------------------------------");
  Serial.println("Getting ticker data for " + ticker);



  CMCTickerResponse response = api.GetTickerInfo(ticker, "usd");
  if (response.error == "") {
    // Serial.print("ID: ");
    display.clearDisplay(); display.setCursor(1, 1);  display.print("ID: "); display.setCursor(30, 1); display.print(response.id);
    delay(2000);
    display.display();
    display.clearDisplay();
    display.setCursor(1, 10);  display.print("Name: "); display.setCursor(30, 10); display.print(response.name);
    delay(2000);
    display.display();
    display.clearDisplay();
    display.setCursor(1, 20);  display.print("Symbol: "); display.setCursor(50, 20); display.print(response.symbol);
    delay(2000);
    display.display();
    display.clearDisplay();
    display.setCursor(1, 30);  display.print("Rank: "); display.setCursor(50, 30); display.print(response.rank);
    delay(2000);
    display.display();
    display.clearDisplay();
    display.setCursor(1, 1);  display.print("Price in BTC: "); display.setCursor(1, 20); display.print(response.price_btc);
    delay(2000);
    display.display();
    display.clearDisplay();
    display.setCursor(1, 1);  display.print("Percent       Change 1h: "); display.setCursor(1, 20); display.print(response.percent_change_1h);
    delay(2000);
    display.display();
    display.clearDisplay();
    display.setCursor(1, 1);  display.print("Percent       Change 24h: "); display.setCursor(1, 20); display.print(response.percent_change_24h);
    delay(2000);
    display.display();
    display.clearDisplay();
    display.setCursor(1, 1);  display.print("Percent       Change 7d: "); display.setCursor(1, 20); display.print(response.percent_change_7d);
    delay(2000);
    display.display();
    display.clearDisplay();
    display.setCursor(1, 1);  display.print("Price in USD: "); display.setCursor(1, 20); display.print(response.price_usd);
   
    display.display();

  } else {
    Serial.print("Error getting data: ");
    Serial.println(response.error);
    display.setCursor(1, 1);  display.print("Error getting data: "); display.setCursor(1, 20); display.print(response.error);
  }
  Serial.println("---------------------------------");
}

void loop() {
  unsigned long timeNow = millis();
  if ((timeNow > api_due_time))  {
    printTickerData("bitcoin");
    api_due_time = timeNow + api_mtbs;
  }
}
